# Example 1: Basic Concept
#
# There is a 16 element array of hypothetical temperatures provided, which will get encoded into a
# PNG Package File (PPF), which is essentially a collection of PNGs in a .zip archive with a plain
# text file containing information about how to decode the PNGs.

from pngpack import *
import numpy as np


# A one-dimensional array of data
temperature = np.array([294.76703893, 298.54229312, 297.68941060, 288.01851419, 294.03889221, 300.56024075, 301.25782887, 300.11737928, 295.91656354, 292.28935541, 293.94085487, 294.47850144, 293.79480002, 288.96294355, 299.31238691, 293.71648222])


# Create a new file
myFile = Pack()


# Save the array into the new file
myFile.packGrid("T", temperature)


# Save the file
myFile.save("16 Temperatures")


# Load the file that was saved above
loadedFile = Pack("16 Temperatures.ppf")


# Extract the array that was just saved
extracted = loadedFile.unpackGrid("T")

print(extracted)


# Calculate the mean data loss for our reference
error = np.abs(extracted - temperature)
print("Maximum loss:", error.max())
print("Average loss:", error.mean())

