# Example 7: Encoding Masked Arrays
#
# Several real world datasets will have missing data. Masked arrays are used to mark where data is
# missing, and PNG-Pack is built to automatically handle masked arrays without any extra steps.

from pngpack import *
import numpy as np


maskedArray = np.ma.array([10.56, 49.95, 40.38, 24.55, 27.85, 33.32], mask=[0, 0, 0, 1, 0, 1])

print(maskedArray)


myFile = Pack()

myFile.packGrid("mask", maskedArray)
myFile.save("mask")

loadedFile = Pack("mask.ppf")

recovered = loadedFile.unpackGrid("mask")

print(recovered)


# In the actual file, masked values are assigned a value of 0xff (255) for all color channels.